diff --git a/SHADE_Engine/src/Physics/SHPhysicsSystem.cpp b/SHADE_Engine/src/Physics/SHPhysicsSystem.cpp
index 7dc6c44e..1c6e79d7 100644
--- a/SHADE_Engine/src/Physics/SHPhysicsSystem.cpp
+++ b/SHADE_Engine/src/Physics/SHPhysicsSystem.cpp
@@ -16,6 +16,9 @@
 // Project Headers
 #include "ECS_Base/Managers/SHComponentManager.h"
 #include "ECS_Base/Managers/SHEntityManager.h"
+#include "ECS_Base/Managers/SHSystemManager.h"
+#include "Editor/SHEditor.hpp"
+#include "Math/SHMathHelpers.h"
 #include "Scene/SHSceneManager.h"
 #include "Math/Transform/SHTransformComponent.h"
 
@@ -174,11 +177,9 @@ namespace SHADE
 
   void SHPhysicsSystem::Init()
   {
-    using namespace rp3d;
-
     // Create a physics world with the default settings
-    PhysicsWorld::WorldSettings settings;
-    settings.gravity                            = Vector3{ 0.0f, -9.81f, 0.0f };
+    rp3d::PhysicsWorld::WorldSettings settings;
+    settings.gravity                            = SHVec3{ 0.0f, -9.81f, 0.0f };
     settings.isSleepingEnabled                  = true;
     settings.defaultVelocitySolverNbIterations  = 8;
     settings.defaultPositionSolverNbIterations  = 3;
@@ -189,6 +190,16 @@ namespace SHADE
 
     // Set up solvers
     world->setContactsPositionCorrectionTechnique(rp3d::ContactsPositionCorrectionTechnique::SPLIT_IMPULSES);
+
+    // Subscribe to component events
+
+    const std::shared_ptr ADD_COMPONENT_RECEIVER { std::make_shared<SHEventReceiverSpec<SHPhysicsSystem>>(this, &SHPhysicsSystem::AddPhysicsComponent) };
+    const ReceiverPtr ADD_COMPONENT_RECEIVER_PTR = std::dynamic_pointer_cast<SHEventReceiver>(ADD_COMPONENT_RECEIVER);
+    SHEventManager::SubscribeTo(SH_COMPONENT_ADDED_EVENT, ADD_COMPONENT_RECEIVER_PTR);
+
+    const std::shared_ptr REMOVE_COMPONENT_RECEIVER { std::make_shared<SHEventReceiverSpec<SHPhysicsSystem>>(this, &SHPhysicsSystem::RemovePhysicsComponent) };
+    const ReceiverPtr REMOVE_COMPONENT_RECEIVER_PTR = std::dynamic_pointer_cast<SHEventReceiver>(REMOVE_COMPONENT_RECEIVER);
+    SHEventManager::SubscribeTo(SH_COMPONENT_REMOVED_EVENT, REMOVE_COMPONENT_RECEIVER_PTR);
   }
 
   void SHPhysicsSystem::Exit()
@@ -196,128 +207,87 @@ namespace SHADE
     factory.destroyPhysicsWorld(world);
   }
 
-  void SHPhysicsSystem::AddRigidBody(EntityID entityID) noexcept
-  {
-    //#ifdef _DEBUG
-    //  SHLOG_INFO("Adding a Rigidbody to the Physics World.")
-    //#endif
-
-    auto* physicsObject = CreatePhysicsObject(entityID);
-
-    physicsObject->CreateRigidBody
-    (
-      EnsureTransform(entityID), 
-      SHComponentManager::GetComponent<SHRigidBodyComponent>(entityID), 
-      SHComponentManager::GetComponent_s<SHColliderComponent>(entityID)
-    );
-  }
-
-  void SHPhysicsSystem::AddCollider(EntityID entityID) noexcept
-  {
-    //#ifdef _DEBUG
-    //  SHLOG_INFO("Adding a Collider to the Physics World.")
-    //#endif
-
-    auto* physicsObject = CreatePhysicsObject(entityID);
-
-    physicsObject->CreateCollisionBody
-    (
-      EnsureTransform(entityID), 
-      SHComponentManager::GetComponent<SHColliderComponent>(entityID)
-    );
-  }
-
-  void SHPhysicsSystem::RemoveRigidBody(EntityID entityID) noexcept
-  {
-    #ifdef _DEBUG
-      SHLOG_INFO("Removing a Rigidbody from the Physics World.")
-    #endif
-
-    auto* physicsObject = GetPhysicsObject(entityID);
-    SHASSERT(physicsObject != nullptr, "Physics object has been lost from the world!")
-
-    physicsObject->DestroyRigidBody(SHComponentManager::GetComponent_s<SHColliderComponent>(entityID));
-
-    if (physicsObject->rp3dBody == nullptr)
-      DestroyPhysicsObject(entityID);
-  }
-
-  void SHPhysicsSystem::RemoveCollider(EntityID entityID) noexcept
-  {
-    #ifdef _DEBUG
-      SHLOG_INFO("Removing a Collider from the Physics World.")
-    #endif
-  }
-
-  void SHPhysicsSystem::AddForce(EntityID entityID, const SHVec3& force) const noexcept
-  {
-    
-  }
-
-  void SHPhysicsSystem::AddForceAtLocalPos(EntityID entityID, const SHVec3& force, const SHVec3& localPos) const noexcept
-  {
-    
-  }
-
-  void SHPhysicsSystem::AddForceAtWorldPos(EntityID entityID, const SHVec3& force, const SHVec3& worldPos) const noexcept
-  {
-    
-  }
-
-  void SHPhysicsSystem::AddRelativeForce(EntityID entityID, const SHVec3& relativeForce) const noexcept
-  {
-    
-  }
-
-  void SHPhysicsSystem::AddRelativeForceAtLocalPos(EntityID entityID, const SHVec3& relativeForce, const SHVec3& localPos) const noexcept
-  {
-    
-  }
-
-  void SHPhysicsSystem::AddRelativeForceAtWorldPos(EntityID entityID, const SHVec3& relativeForce, const SHVec3& worldPos) const noexcept
-  {
-    
-  }
-
-  void SHPhysicsSystem::AddTorque(EntityID entityID, const SHVec3& torque) const noexcept
-  {
-    
-  }
-
-  void SHPhysicsSystem::AddRelativeTorque(EntityID entityID, const SHVec3& relativeTorque) const noexcept
-  {
-    
-  }
-
   void SHPhysicsSystem::AddCollisionShape(EntityID entityID, SHCollider* collider)
   {
     auto* physicsObject = GetPhysicsObject(entityID);
-    physicsObject->AddCollider(collider);
+
+    const SHPhysicsColliderAddedEvent COLLIDER_ADDED_EVENT_DATA
+    {
+      .entityID       = entityID
+    , .colliderType   = collider->GetType()
+    , .colliderIndex  = physicsObject->AddCollider(collider) 
+    };
+
+    SHEventManager::BroadcastEvent<SHPhysicsColliderAddedEvent>(COLLIDER_ADDED_EVENT_DATA, SH_PHYSICS_COLLIDER_ADDED_EVENT);
   }
 
   void SHPhysicsSystem::RemoveCollisionShape(EntityID entityID, int index)
   {
-    
+    auto* physicsObject = GetPhysicsObject(entityID);
+    physicsObject->RemoveCollider(index);
+
+    const SHPhysicsColliderRemovedEvent COLLIDER_REMOVED_EVENT_DATA
+    {
+      .entityID       = entityID
+    , .colliderIndex  = index
+    };
+
+    SHEventManager::BroadcastEvent<SHPhysicsColliderRemovedEvent>(COLLIDER_REMOVED_EVENT_DATA, SH_PHYSICS_COLLIDER_REMOVED_EVENT);
   }
 
   void SHPhysicsSystem::PhysicsPreUpdate::Execute(double) noexcept
   {
     auto* system = reinterpret_cast<SHPhysicsSystem*>(GetSystem());
 
+    // Sync transforms
+    for (auto& [entityID, physicsObject] : system->map)
+    {
+      // Ensure a valid physics Object
+      if (physicsObject.rp3dBody == nullptr)
+        continue;
+
+      auto* rigidBodyComponent = SHComponentManager::GetComponent_s<SHRigidBodyComponent>(entityID);
+
+      // Clear all forces and velocities if editor is not in play
+      if (SHSystemManager::GetSystem<SHEditor>()->editorState == SHEditor::State::STOP)
+      {
+        if (rigidBodyComponent)
+        {
+          auto* rp3dRigidBody = reinterpret_cast<rp3d::RigidBody*>(physicsObject.rp3dBody);
+          rp3dRigidBody->resetForce();
+          rp3dRigidBody->resetTorque();
+          rp3dRigidBody->setLinearVelocity(SHVec3::Zero);
+          rp3dRigidBody->setAngularVelocity(SHVec3::Zero);
+        }
+      }
+
+      const auto* transformComponent = SHComponentManager::GetComponent_s<SHTransformComponent>(entityID);
+      if (transformComponent && transformComponent->HasChanged())
+      {
+        const auto WORLD_POS = transformComponent->GetWorldPosition();
+        const auto WORLD_ROT = transformComponent->GetWorldOrientation();
+
+        physicsObject.SetPosition(WORLD_POS);
+        physicsObject.SetOrientation(WORLD_ROT);
+
+        if (rigidBodyComponent)
+        {
+          rigidBodyComponent->position    = WORLD_POS;
+          rigidBodyComponent->orientation = WORLD_ROT;
+        }
+
+        auto* colliderComponent = SHComponentManager::GetComponent_s<SHColliderComponent>(entityID);
+        if (colliderComponent)
+        {
+          colliderComponent->position    = WORLD_POS;
+          colliderComponent->orientation = WORLD_ROT;
+        }
+      }
+    }
+
     // Update bodies and colliders if component is dirty
     system->SyncRigidBodyComponents(SHComponentManager::GetDense<SHRigidBodyComponent>());
     system->SyncColliderComponents(SHComponentManager::GetDense<SHColliderComponent>());
-
-    // Sync transforms
-    for (auto& physicsObject : system->map | std::views::values)
-    {
-      const auto* TF = SHComponentManager::GetComponent<SHTransformComponent>(physicsObject.entityID);
-      if (TF->HasChanged())
-      {
-        physicsObject.SetPosition(TF->GetWorldPosition());
-        physicsObject.SetRotation(TF->GetWorldRotation());
-      }
-    }
   }
 
   void SHPhysicsSystem::PhysicsFixedUpdate::Execute(double dt) noexcept
@@ -358,7 +328,7 @@ namespace SHADE
   /* Private Function Member Definitions                                               */
   /*-----------------------------------------------------------------------------------*/
 
-  SHPhysicsObject* SHPhysicsSystem::CreatePhysicsObject(EntityID entityID) noexcept
+  SHPhysicsObject* SHPhysicsSystem::EnsurePhysicsObject(EntityID entityID) noexcept
   {
     const auto it = map.find(entityID);
     if (it == map.end())
@@ -450,15 +420,18 @@ namespace SHADE
 
       const rp3d::Transform CURRENT_TF = physicsObject.rp3dBody->getTransform();
 
+      auto* rigidBodyComponent  = SHComponentManager::GetComponent_s<SHRigidBodyComponent>(entityID);
+      auto* colliderComponent   = SHComponentManager::GetComponent_s<SHColliderComponent>(entityID);
+
       // Check if transform should be interpolated
       
-      if (physicsObject.isRigidBody)
+      if (rigidBodyComponent != nullptr)
       {
-        auto* rbComponent = SHComponentManager::GetComponent<SHRigidBodyComponent>(entityID);
-        if (rbComponent->GetType() == SHRigidBodyComponent::Type::STATIC)
+        
+        if (rigidBodyComponent->GetType() == SHRigidBodyComponent::Type::STATIC)
           continue;
 
-        if (rbComponent->IsInterpolating())
+        if (rigidBodyComponent->IsInterpolating())
         {
           const rp3d::Transform PREV_TF         = physicsObject.prevTransform;
           const rp3d::Transform INTERPOLATED_TF = rp3d::Transform::interpolateTransforms(PREV_TF, CURRENT_TF, static_cast<rp3d::decimal>(interpolationFactor));
@@ -473,12 +446,12 @@ namespace SHADE
           rp3dRot = CURRENT_TF.getOrientation();
         }
 
-        rbComponent->position     = CURRENT_TF.getPosition();
-        rbComponent->orientation  = CURRENT_TF.getOrientation();
+        rigidBodyComponent->position     = CURRENT_TF.getPosition();
+        rigidBodyComponent->orientation  = CURRENT_TF.getOrientation();
 
-        if (physicsObject.hasColliders)
+        if (colliderComponent != nullptr)
         {
-          auto* colliderComponent = SHComponentManager::GetComponent<SHColliderComponent>(entityID);
+          
           colliderComponent->position     = CURRENT_TF.getPosition();
           colliderComponent->orientation  = CURRENT_TF.getOrientation();
         }
@@ -490,29 +463,148 @@ namespace SHADE
       }
 
       // Convert RP3D Transform to SHADE
-      auto* tfComponent = SHComponentManager::GetComponent<SHTransformComponent>(entityID);
-      tfComponent->SetWorldPosition(rp3dPos);
-      tfComponent->SetWorldRotation(SHQuaternion{ rp3dRot }.ToEuler());
-
+      auto* transformComponent = SHComponentManager::GetComponent<SHTransformComponent>(entityID);
+      transformComponent->SetWorldPosition(rp3dPos);
+      transformComponent->SetWorldOrientation(rp3dRot);
 
       // Cache transforms
       physicsObject.prevTransform = CURRENT_TF;
     }
   }
 
-  SHTransformComponent* SHPhysicsSystem::EnsureTransform(EntityID entityID)
+  SHEventHandle SHPhysicsSystem::AddPhysicsComponent(SHEventPtr addComponentEvent)
   {
-    auto* tf = SHComponentManager::GetComponent_s<SHTransformComponent>(entityID);
+    const auto& EVENT_DATA = reinterpret_cast<const SHEventSpec<SHComponentAddedEvent>*>(addComponentEvent.get());
 
-    // Possibly redundant
-    if (!tf)
+    static const auto RIGID_BODY_ID = ComponentFamily::GetID<SHRigidBodyComponent>();
+    static const auto COLLIDER_ID   = ComponentFamily::GetID<SHColliderComponent>();
+
+    const auto ADDED_ID = EVENT_DATA->data->addedComponentType;
+    const bool IS_PHYSICS_COMPONENT = ADDED_ID == RIGID_BODY_ID || ADDED_ID == COLLIDER_ID;
+    if (IS_PHYSICS_COMPONENT)
     {
-      SHComponentManager::AddComponent<SHTransformComponent>(entityID);
-      tf = SHComponentManager::GetComponent<SHTransformComponent>(entityID);
+      const EntityID ENTITY_ID = EVENT_DATA->data->eid;
+      auto* physicsObject = EnsurePhysicsObject(ENTITY_ID);
+
+      auto* transformComponent = SHComponentManager::GetComponent_s<SHTransformComponent>(ENTITY_ID);
+      if (transformComponent == nullptr)
+      {
+        SHLOG_ERROR("Entity {} cannot add a Physics Component without a Transform! Component not created!", ENTITY_ID)
+        return EVENT_DATA->handle;
+      }
+
+      auto* rigidBodyComponent  = SHComponentManager::GetComponent_s<SHRigidBodyComponent>(ENTITY_ID);
+      auto* colliderComponent   = SHComponentManager::GetComponent_s<SHColliderComponent>(ENTITY_ID);
+
+      if (ADDED_ID == RIGID_BODY_ID)
+      {
+        if (colliderComponent != nullptr)
+        {
+          world->destroyCollisionBody(physicsObject->rp3dBody);
+          physicsObject->rp3dBody = nullptr;
+        }
+
+        rigidBodyComponent->position    = transformComponent->GetWorldPosition();
+        rigidBodyComponent->orientation = transformComponent->GetWorldOrientation();
+
+        physicsObject->rp3dBody = world->createRigidBody
+        (
+          rp3d::Transform{ rigidBodyComponent->position, rigidBodyComponent->orientation }
+        );
+
+        rigidBodyComponent->rp3dBody = reinterpret_cast<rp3d::RigidBody*>(physicsObject->rp3dBody);
+
+        // Add collision shapes back into the body
+        if (colliderComponent != nullptr)
+        {
+          for (auto& collider : colliderComponent->colliders | std::views::keys)
+            physicsObject->AddCollider(&collider);
+        }
+      }
+
+      if (ADDED_ID == COLLIDER_ID)
+      {
+        SHASSERT(colliderComponent != nullptr, "Collider Component was not added to Entity " + std::to_string(ENTITY_ID) + "!");
+
+        colliderComponent->position    = transformComponent->GetWorldPosition();
+        colliderComponent->orientation = transformComponent->GetWorldOrientation();
+
+        if (physicsObject->rp3dBody == nullptr)
+        {
+          physicsObject->rp3dBody = world->createCollisionBody
+          (
+            rp3d::Transform{ colliderComponent->position, colliderComponent->orientation }
+          );
+        }
+          
+        // Add Collision Shapes
+        for (auto& collider : colliderComponent->colliders | std::views::keys)
+          physicsObject->AddCollider(&collider);
+      }
     }
 
-    return tf;
+    return EVENT_DATA->handle;
   }
 
+  SHEventHandle SHPhysicsSystem::RemovePhysicsComponent(SHEventPtr removeComponentEvent)
+  {
+    const auto& EVENT_DATA = reinterpret_cast<const SHEventSpec<SHComponentRemovedEvent>*>(removeComponentEvent.get());
+
+    static const auto RIGID_BODY_ID = ComponentFamily::GetID<SHRigidBodyComponent>();
+    static const auto COLLIDER_ID   = ComponentFamily::GetID<SHColliderComponent>();
+
+    const auto REMOVED_ID = EVENT_DATA->data->removedComponentType;
+    const bool IS_PHYSICS_COMPONENT = REMOVED_ID == RIGID_BODY_ID || REMOVED_ID == COLLIDER_ID;
+    if (IS_PHYSICS_COMPONENT)
+    {
+      const EntityID ENTITY_ID = EVENT_DATA->data->eid;
+      auto* physicsObject = GetPhysicsObject(ENTITY_ID);
+
+      SHASSERT(physicsObject != nullptr, "Physics object has been lost from the world!")
+
+      if (REMOVED_ID == RIGID_BODY_ID)
+      {
+        world->destroyRigidBody(reinterpret_cast<rp3d::RigidBody*>(physicsObject->rp3dBody));
+        physicsObject->rp3dBody       = nullptr;
+
+        auto* colliderComponent = SHComponentManager::GetComponent_s<SHColliderComponent>(ENTITY_ID);
+        if (colliderComponent != nullptr)
+        {
+          // Preserve colliders as a collision body
+          physicsObject->rp3dBody = world->createCollisionBody
+          (
+            rp3d::Transform{ colliderComponent->position, colliderComponent->orientation }
+          );
+
+          for (auto& collider : colliderComponent->colliders | std::views::keys)
+            physicsObject->AddCollider(&collider);
+        }
+
+        // Wake up all physics objects
+        for (auto& [entityID, object] : map)
+        {
+          if (SHComponentManager::HasComponent<SHRigidBodyComponent>(entityID))
+            reinterpret_cast<rp3d::RigidBody*>(object.rp3dBody)->setIsSleeping(false);
+        }
+      }
+
+      if (REMOVED_ID == COLLIDER_ID)
+      {
+        // Remove all colliders
+        const int NUM_COLLIDERS = static_cast<int>(physicsObject->rp3dBody->getNbColliders());
+
+        for (int i = NUM_COLLIDERS - 1; i >= 0; --i)
+        {
+          auto* collider = physicsObject->rp3dBody->getCollider(i);
+          physicsObject->rp3dBody->removeCollider(collider);
+        }
+      }
+
+      if (physicsObject->rp3dBody == nullptr)
+          DestroyPhysicsObject(ENTITY_ID);
+    }
+
+    return EVENT_DATA->handle;
+  }
 
 } // namespace SHADE
\ No newline at end of file
diff --git a/SHADE_Engine/src/Physics/SHPhysicsSystem.h b/SHADE_Engine/src/Physics/SHPhysicsSystem.h
index bc6a1ba2..a3c3bea1 100644
--- a/SHADE_Engine/src/Physics/SHPhysicsSystem.h
+++ b/SHADE_Engine/src/Physics/SHPhysicsSystem.h
@@ -16,14 +16,14 @@
 #include <reactphysics3d/reactphysics3d.h>
 
 // Project Headers
-#include "SHPhysicsObject.h"
 #include "Components/SHRigidBodyComponent.h"
 #include "Components/SHColliderComponent.h"
-#include "Math/Transform/SHTransformComponent.h"
-
-#include "Scene/SHSceneGraph.h"
 #include "ECS_Base/System/SHSystemRoutine.h"
 #include "ECS_Base/System/SHFixedSystemRoutine.h"
+#include "Math/Transform/SHTransformComponent.h"
+#include "Scene/SHSceneGraph.h"
+#include "SHPhysicsObject.h"
+
 
 
 namespace SHADE
@@ -32,7 +32,7 @@ namespace SHADE
   /* Type Definitions                                                                  */
   /*-----------------------------------------------------------------------------------*/
 
-  class SH_API SHPhysicsSystem : public SHSystem
+  class SH_API SHPhysicsSystem final : public SHSystem
   {
   public:
     /*---------------------------------------------------------------------------------*/
@@ -85,21 +85,10 @@ namespace SHADE
     void  Init                         () override;
     void  Exit                         () override;
 
-    void  AddRigidBody                (EntityID entityID) noexcept;
-    void  AddCollider                 (EntityID entityID) noexcept;
-    void  RemoveRigidBody             (EntityID entityID) noexcept;
-    void  RemoveCollider              (EntityID entityID) noexcept;
-
-    void  AddForce                    (EntityID entityID, const SHVec3& force) const noexcept;
-    void  AddForceAtLocalPos          (EntityID entityID, const SHVec3& force, const SHVec3& localPos) const noexcept;
-    void  AddForceAtWorldPos          (EntityID entityID, const SHVec3& force, const SHVec3& worldPos) const noexcept;
-
-    void  AddRelativeForce            (EntityID entityID, const SHVec3& relativeForce) const noexcept;
-    void  AddRelativeForceAtLocalPos  (EntityID entityID, const SHVec3& relativeForce, const SHVec3& localPos)  const noexcept;
-    void  AddRelativeForceAtWorldPos  (EntityID entityID, const SHVec3& relativeForce, const SHVec3& worldPos)  const noexcept;
-
-    void  AddTorque                   (EntityID entityID, const SHVec3& torque) const noexcept;
-    void  AddRelativeTorque           (EntityID entityID, const SHVec3& relativeTorque) const noexcept;
+    //void  AddRigidBody                (EntityID entityID) noexcept;
+    //void  AddCollider                 (EntityID entityID) noexcept;
+    //void  RemoveRigidBody             (EntityID entityID) noexcept;
+    //void  RemoveCollider              (EntityID entityID) noexcept;
 
     void  AddCollisionShape           (EntityID entityID, SHCollider* collider);
     void  RemoveCollisionShape        (EntityID entityID, int index);
@@ -108,10 +97,7 @@ namespace SHADE
     /* System Routines                                                                 */
     /*---------------------------------------------------------------------------------*/
 
-    /**
-     * @brief Synchronises RP3D with SHADE
-    */
-    class SH_API PhysicsPreUpdate : public SHSystemRoutine
+    class SH_API PhysicsPreUpdate final : public SHSystemRoutine
     {
     public:
       /*-------------------------------------------------------------------------------*/
@@ -127,7 +113,7 @@ namespace SHADE
       void Execute(double dt) noexcept override;
     };
 
-    class SH_API PhysicsFixedUpdate : public SHFixedSystemRoutine
+    class SH_API PhysicsFixedUpdate final : public SHFixedSystemRoutine
     {
     public:
       /*-------------------------------------------------------------------------------*/
@@ -143,7 +129,7 @@ namespace SHADE
       void Execute      (double dt) noexcept override;
     };
 
-    class SH_API PhysicsPostUpdate : public SHSystemRoutine
+    class SH_API PhysicsPostUpdate final : public SHSystemRoutine
     {
     public:
       /*-------------------------------------------------------------------------------*/
@@ -170,15 +156,14 @@ namespace SHADE
     /* Data Members                                                                    */
     /*---------------------------------------------------------------------------------*/
 
-    // TODO(Diren): Store interpFactor
-
     bool                      worldUpdated;
 
     double                    interpolationFactor;
     double                    fixedDT;
-    rp3d::PhysicsWorld*       world;
 
+    rp3d::PhysicsWorld*       world;
     rp3d::PhysicsCommon       factory;
+
     EntityObjectMap           map;
 
 
@@ -186,7 +171,7 @@ namespace SHADE
     /*---------------------------------------------------------------------------------*/
     /* Function Members                                                                */
     /*---------------------------------------------------------------------------------*/
-    SHPhysicsObject*  CreatePhysicsObject       (EntityID entityID)                                     noexcept;
+    SHPhysicsObject*  EnsurePhysicsObject       (EntityID entityID)                                     noexcept;
     SHPhysicsObject*  GetPhysicsObject          (EntityID entityID)                                     noexcept;
     void              DestroyPhysicsObject      (EntityID entityID)                                     noexcept;
 
@@ -194,11 +179,26 @@ namespace SHADE
     void              SyncRigidBodyComponents   (std::vector<SHRigidBodyComponent>& denseArray)         noexcept;
     void              SyncColliderComponents    (std::vector<SHColliderComponent>& denseArray)          noexcept;
     void              SyncTransforms            ()                                                      noexcept;
-    // TODO(Diren): Trigger handling
 
-    // TODO(Diren): Remove when responsibility shifted to editor
-    SHTransformComponent* EnsureTransform       (EntityID entityID);
+    SHEventHandle     AddPhysicsComponent       (SHEventPtr addComponentEvent);
+    SHEventHandle     RemovePhysicsComponent    (SHEventPtr removeComponentEvent);
   };
 
+  /*-----------------------------------------------------------------------------------*/
+  /* Event Data Definitions                                                            */
+  /*-----------------------------------------------------------------------------------*/
+
+  struct SHPhysicsColliderAddedEvent
+  {
+    EntityID          entityID;
+    SHCollider::Type  colliderType;
+    int               colliderIndex;
+  };
+
+  struct SHPhysicsColliderRemovedEvent
+  {
+    EntityID          entityID;
+    int               colliderIndex;
+  };
 
 } // namespace SHADE
\ No newline at end of file
diff --git a/SHADE_Engine/src/Resource/SHResourceManager.hpp b/SHADE_Engine/src/Resource/SHResourceManager.hpp
index 54ced715..cff4e84b 100644
--- a/SHADE_Engine/src/Resource/SHResourceManager.hpp
+++ b/SHADE_Engine/src/Resource/SHResourceManager.hpp
@@ -15,6 +15,7 @@ of DigiPen Institute of Technology is prohibited.
 #include "SHResourceManager.h"
 // Project Includes
 #include "Assets/SHAssetManager.h"
+#include "Assets/Asset Types/SHAssetIncludes.h"
 #include "Graphics/MiddleEnd/Interface/SHGraphicsSystem.h"
 #include "ECS_Base/Managers/SHSystemManager.h"
 #include "Tools/SHLog.h"
@@ -48,7 +49,7 @@ namespace SHADE
         throw std::runtime_error("[SHResourceManager] Attempted to load graphics resource without a SHGraphicsSystem installed.");
 
       // Load
-      const SHMeshAsset* assetData = SHAssetManager::GetMesh(assetId);
+      const SHMeshAsset* assetData = SHAssetManager::GetData<SHMeshAsset>(assetId);
       if (assetData == nullptr)
       {
         SHLog::Warning("[SHResourceManager] Attempted to load an asset with an invalid Asset ID.");
@@ -80,7 +81,7 @@ namespace SHADE
         throw std::runtime_error("[SHResourceManager] Attempted to load graphics resource without a SHGraphicsSystem installed.");
 
       // Load
-      const SHTextureAsset* assetData = SHAssetManager::GetTexture(assetId);
+      const SHTextureAsset* assetData = SHAssetManager::GetData<SHTextureAsset>(assetId);
       if (assetData == nullptr)
       {
         SHLog::Warning("[SHResourceManager] Attempted to load an asset with an invalid Asset ID.");
@@ -133,7 +134,7 @@ namespace SHADE
   /* Query Functions                                                                   */
   /*-----------------------------------------------------------------------------------*/
   template<typename T>
-  static std::optional<AssetID> SHResourceManager::GetAssetID(Handle<T> handle)
+  std::optional<AssetID> SHResourceManager::GetAssetID(Handle<T> handle)
   {
     const Handle GENERIC_HANDLE = Handle(handle);
     auto [typedHandleMap, typedAssetIdMap] = getAssetHandleMap<T>();
diff --git a/SHADE_Engine/src/Scene/SHSceneGraph.cpp b/SHADE_Engine/src/Scene/SHSceneGraph.cpp
index bbbdb7e4..950fd6a0 100644
--- a/SHADE_Engine/src/Scene/SHSceneGraph.cpp
+++ b/SHADE_Engine/src/Scene/SHSceneGraph.cpp
@@ -15,6 +15,7 @@
 
 // Project Headers
 #include "ECS_Base/Managers/SHEntityManager.h"
+#include "Events/SHEventManager.hpp"
 #include "Tools/SHLogger.h"
 #include "Tools/SHException.h"
 
@@ -317,6 +318,11 @@ namespace SHADE
     if (parentNode == nullptr)
     {
       SHLOG_WARNING("Removing Entity {}'s parent", entityID)
+
+      if (parent)
+        parent->RemoveChild(this);
+
+      return;
     }
 
     // Handle self assignment
@@ -359,10 +365,19 @@ namespace SHADE
     }
     ////////////////////////////////////////
 
+    const SHSceneGraphChangeParentEvent EVENT_DATA
+    {
+      .node       = NODE_ITER->second
+    , .oldParent  = NODE_ITER->second->GetParent()
+    , .newParent  = parent ? parent : root
+    };
+
     if (parent == nullptr)
       parent = root;
 
     NODE_ITER->second->SetParent(parent);
+
+    SHEventManager::BroadcastEvent<SHSceneGraphChangeParentEvent>(EVENT_DATA, SH_SCENEGRAPH_CHANGE_PARENT_EVENT);
   }
 
   void SHSceneGraph::SetParent(EntityID entityID, EntityID parent) const noexcept
@@ -396,8 +411,17 @@ namespace SHADE
     }
     ////////////////////////////////////////
 
+    const SHSceneGraphChangeParentEvent EVENT_DATA
+    {
+      .node       = NODE_ITER->second
+    , .oldParent  = NODE_ITER->second->GetParent()
+    , .newParent  = PARENT_ITER->second
+    };
+
     SHSceneNode* currentNode = NODE_ITER->second;
     currentNode->SetParent(PARENT_ITER->second);
+
+    SHEventManager::BroadcastEvent<SHSceneGraphChangeParentEvent>(EVENT_DATA, SH_SCENEGRAPH_CHANGE_PARENT_EVENT);
   }
 
   /*-----------------------------------------------------------------------------------*/
@@ -558,7 +582,7 @@ namespace SHADE
       ReleaseNode(node);
   }
 
-  void SHSceneGraph::Traverse (const UnaryPredicate& predicate) const
+  void SHSceneGraph::Traverse (const UnaryFunction& predicate) const
   {
     TraverseAndInvokePredicate(root, predicate);
   }
@@ -597,7 +621,7 @@ namespace SHADE
     delete node;
   }
 
-  void SHSceneGraph::TraverseAndInvokePredicate(const SHSceneNode* node, const UnaryPredicate& predicate)
+  void SHSceneGraph::TraverseAndInvokePredicate(const SHSceneNode* node, const UnaryFunction& predicate)
   {
     for (auto* child : node->children)
     { 
diff --git a/SHADE_Engine/src/Scene/SHSceneGraph.h b/SHADE_Engine/src/Scene/SHSceneGraph.h
index 3f3ebf92..b52fd1ff 100644
--- a/SHADE_Engine/src/Scene/SHSceneGraph.h
+++ b/SHADE_Engine/src/Scene/SHSceneGraph.h
@@ -97,9 +97,8 @@ namespace SHADE
     /* Type Definitions                                                                */
     /*---------------------------------------------------------------------------------*/
 
-    using EntityNodeMap       = std::unordered_map<EntityID, SHSceneNode*>;
-
-    using UnaryPredicate      = std::function<void(SHSceneNode*)>;
+    using EntityNodeMap = std::unordered_map<EntityID, SHSceneNode*>;
+    using UnaryFunction = std::function<void(SHSceneNode*)>;
     
 
     /*---------------------------------------------------------------------------------*/
@@ -143,8 +142,7 @@ namespace SHADE
     bool          RemoveNode  (SHSceneNode* nodeToRemove)                         noexcept;
     void          Reset       ()                                                  noexcept;
 
-    void          Traverse    (const UnaryPredicate& predicate)                   const;
-    
+    void          Traverse    (const UnaryFunction& predicate)                    const;
 
   private:
     /*---------------------------------------------------------------------------------*/
@@ -160,8 +158,18 @@ namespace SHADE
 
     SHSceneNode*  AllocateNode                (EntityID entityID);
     void          ReleaseNode                 (SHSceneNode* node) noexcept;
-    static void   TraverseAndInvokePredicate  (const SHSceneNode* node, const UnaryPredicate& predicate);
+    static void   TraverseAndInvokeFunction  (const SHSceneNode* node, const UnaryFunction& function);
   };
 
+  /*-----------------------------------------------------------------------------------*/
+  /* Event Data Definitions                                                            */
+  /*-----------------------------------------------------------------------------------*/
+
+  struct SHSceneGraphChangeParentEvent
+  {
+    SHSceneNode* node;
+    SHSceneNode* oldParent;
+    SHSceneNode* newParent;
+  };
 
 } // namespace SHADE
\ No newline at end of file
diff --git a/SHADE_Engine/src/Tools/SHUtilities.h b/SHADE_Engine/src/Tools/SHUtilities.h
index 543c771c..b3d840e7 100644
--- a/SHADE_Engine/src/Tools/SHUtilities.h
+++ b/SHADE_Engine/src/Tools/SHUtilities.h
@@ -42,6 +42,15 @@ namespace SHADE
     template <IsEnum InputType, IsIntegral OutputType = int>
     static constexpr OutputType ConvertEnum(InputType enumClassMember) noexcept;
 
+    /**
+     * @brief     Converts an enum class member from it's type to the underlying type.
+     * @tparam    Enum    Restricted to an enum class
+     * @param[in] value   A member of the specified enum class.
+     * @returns   The value of the enum class member in the output type.
+    */
+    template<typename Enum>
+    static constexpr typename std::underlying_type_t<Enum> ToUnderlying (Enum value) noexcept;
+
   };
 
 } // namespace SHADE
